Subject: Re: git rev-list --all --reflog does not include worktree references

From: Michael J Gruber <[email-masked]>
Date: Tue, 6 Oct 2015 11:39:09 +0200

Andreas Schwab venit, vidit, dixit 05.10.2015 21:08:
> When running git rev-list --all --reflog in the main worktree it doesn't
> include commits only referenced by the worktrees, neither HEAD nor its
> reflog.

HEAD is per worktree, so other worktrees' HEADs should not be included
in "--all", I would think.

> $ git init test
> $ cd test
> # add some commits
> $ touch 1; git add 1; git commit -m 1
> $ touch 2; git add 2; git commit -m 2
> # add new worktree
> $ git worktree add ../test2 master^{}
> $ cd ../test2
> # add more commits
> $ touch 3; git add 3; git commit -m 3
> $ touch 4; git add 4; git commit -m 4
> # create an unreferenced commit
> $ git checkout @^
> # both commands should give the same number of commits
> $ git rev-list --reflog | wc -l
> 4
> $ git -C ../test rev-list --all --reflog | wc -l
> 2
> 
> IIUC this will cause git gc to prune references from worktrees too
> early.

Since HEAD is per worktree, its reflog is so, too. So I think that "git
rev-list" is actually right.

What's worrysome is that running "git prune -n" gives different results,
depending on whether you run it in the main worktree or the new worktree.

In fact, running "git prune" in the main worktree followed by "git
reflog" in the new worktree results in

fatal: bad object HEAD

So, "rev-list" should learn something like "--reflogs" or (better)
"--worktrees" to make it look at worktree specific refs, too, and prune
should use that, of course. "prune" does know about worktrees, but I
guess it looks at HEADs only, not their reflogs.

Michael